<?php

namespace Drupal\noreferrer\Tests;

use Drupal\Core\Url;
use Drupal\simpletest\WebTestBase;

/**
 * Tests the no referrer module.
 *
 * @group No referrer
 */
class NoReferrerTest extends WebTestBase {

  /**
   * Modules to enable.
   *
   * @var array
   */
  public static $modules = ['noreferrer'];

  /**
   * Functional tests for the rel="noreferrer" attribute.
   */
  public function testNoReferrer() {
    $admin_user = $this->drupalCreateUser(['administer site configuration']);
    $this->drupalLogin($admin_user);
    $edit = ['whitelisted_domains' => 'drupal.org example.org'];
    $this->drupalPostForm('admin/config/search/noreferrer', $edit, t('Save configuration'));
    $this->assertIdentical((string) \Drupal::l('test', Url::fromUri('https://example.com/')), '<a href="https://example.com/" rel="noreferrer">test</a>');
    $this->assertIdentical((string) \Drupal::l('test', Url::fromUri('https://drupal.org/')), '<a href="https://drupal.org/">test</a>');
    $this->assertIdentical((string) \Drupal::l('test', Url::fromUri('https://DRUPAL.ORG/')), '<a href="https://DRUPAL.ORG/">test</a>');
    $this->assertIdentical((string) \Drupal::l('test', Url::fromUri('https://api.drupal.org/')), '<a href="https://api.drupal.org/">test</a>');
  }

}
